<script setup lang="ts">
  import { theme } from '@unocss/preset-mini';
  import { Dialog, DialogPanel, TransitionRoot, TransitionChild } from '@headlessui/vue';
  import { MODAL_CONTAINER_ID } from '~/helpers/constants';

  const BACKDROP_STATIC_MODE = 'static';

  const props = withDefaults(
    defineProps<{
      controller: ReturnType<typeof useModal>;
      panelClass?: string;
      modalTitle?: string;
      backdropDisplay?: boolean | 'static';
      offset?: 'left' | 'right' | 'both';
      preventScroll?: boolean;
    }>(),
    {
      panelClass: '',
      modalTitle: '',
      backdropDisplay: true,
      offset: undefined,
      preventScroll: false,
    },
  );
  const slots = useSlots();
  const { controller } = toRefs(props);
  const { isOpen, close } = controller.value;
  const { width } = useWindowSize();
  const { escape } = useMagicKeys();
  const leftSidebarController = useLeftSidebar();
  const rightSidebarController = useRightSidebar();

  const offsetStyles = reactive({ left: 0, right: 0, bottom: 0, top: 0 });

  watch(escape, () => {
    isOpen.value && close();
  });

  const onClickOutside = () => {
    if (props.backdropDisplay !== BACKDROP_STATIC_MODE) close();
  };

  const calculateOffsets = () => {
    if (!props.offset) return;
    const breakpointXlWidth = Number(theme.breakpoints.lg.replace('px', ''));

    if (window.innerWidth < breakpointXlWidth) {
      offsetStyles.left = 0;
      offsetStyles.right = 0;
      offsetStyles.bottom = 0;
      offsetStyles.top = 0;
      return;
    }

    const leftSidebar = document.querySelector('#left-sidebar');
    const rightSidebar = document.querySelector('#right-sidebar');
    const toolbar = document.querySelector('#toolbar');

    const leftRect = leftSidebar?.getBoundingClientRect();
    const rightRect = rightSidebar?.getBoundingClientRect();
    const toolbarRect = toolbar?.getBoundingClientRect();

    if (['left', 'both'].includes(props.offset)) {
      offsetStyles.left = leftRect?.width || 0;
    }

    if (['right', 'both'].includes(props.offset)) {
      offsetStyles.right = rightRect?.width || 0;
    }

    if (toolbarRect) offsetStyles.bottom = toolbarRect.height;
  };

  onMounted(() => calculateOffsets());

  watchDebounced(
    width,
    () => {
      if (props.offset) {
        calculateOffsets();
      }
    },
    {
      debounce: 500,
    },
  );

  watch(leftSidebarController.isOpen, async () => {
    if (props.offset) {
      await nextTick();
      calculateOffsets();
    } else {
      // close
      offsetStyles.left = 0;
    }
  });

  watch(rightSidebarController.isOpen, async (value) => {
    if (props.offset) {
      if (value) {
        // open
        await nextTick();
        calculateOffsets();
      } else {
        // close
        offsetStyles.right = 0;
      }
    }
  });
</script>

<template>
  <Teleport :to="`#${MODAL_CONTAINER_ID}`">
    <TransitionRoot :show="isOpen" appear as="template">
      <Dialog
        as="div"
        class="z-modal fixed overflow-y-auto transition-all"
        aria-labelledby="modal-title"
        role="dialog"
        aria-modal="true"
        :style="{
          left: offsetStyles.left + 'px',
          right: offsetStyles.right + 'px',
          bottom: offsetStyles.bottom + 'px',
          top: offsetStyles.top + 'px',
        }"
        @close="onClickOutside"
      >
        <TransitionChild
          v-if="backdropDisplay"
          as="template"
          enter="duration-300 ease-out"
          enter-from="opacity-0"
          enter-to="opacity-100"
          leave="duration-200 ease-in"
          leave-from="opacity-100"
          leave-to="opacity-0"
        >
          <div class="bg-background-dark absolute inset-0 z-50 bg-opacity-50" />
        </TransitionChild>
        <TransitionChild
          as="template"
          enter="duration-300 ease-out"
          enter-from="opacity-0"
          enter-to="opacity-100"
          leave="duration-200 ease-in"
          leave-from="opacity-100"
          leave-to="opacity-0"
        >
          <DialogPanel
            :class="[
              'z-modal absolute left-0 top-0 flex h-full w-full transform flex-col justify-between rounded-md bg-white shadow-xl',
              'sm:(h-auto -translate-1/2 max-h-90vh max-w-90vw w-fit) sm:(left-1/2 top-1/2)',
              panelClass,
            ]"
          >
            <slot name="header">
              <div
                v-if="modalTitle"
                class="border-b-1 bg-background-raised border-border z-50 flex items-center justify-between rounded-t-none border-0 px-6 py-4 md:rounded-t-md"
              >
                <h3 class="font-bold first-letter:uppercase">
                  {{ modalTitle }}
                </h3>
                <button
                  type="button"
                  class="text-information hover:bg-interactive-hover active:bg-interactive-pressed rounded-md bg-transparent p-2 outline-none"
                  @click="close"
                >
                  <span class="sr-only">{{ $t('close') }}</span>
                  <span class="i-sw-regular:times-xs" />
                </button>
              </div>
            </slot>
            <div
              class="modal-body min-h-0 flex-1 border-2 border-transparent px-6 py-6"
              :class="{
                'overflow-y-scroll': !preventScroll,
              }"
            >
              <slot name="body"></slot>
            </div>
            <div
              v-if="slots.footer"
              class="md:(border-border bg-background-raised rounded-b-md) flex justify-end gap-3 rounded-b-none border-0 border-t bg-transparent px-6 py-4"
            >
              <slot name="footer"></slot>
            </div>
          </DialogPanel>
        </TransitionChild>
      </Dialog>
    </TransitionRoot>
  </Teleport>
</template>
